﻿using System;
using System.Management;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Load                                  += Form_Load;
            this.wmiComboBox.SelectedIndexChanged += wmiComboBox_SelectedIndexChanged;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            this.wmiComboBox.Items.Add("Win32_BaseBoard"                  );
            this.wmiComboBox.Items.Add("Win32_Battery"                    );
            this.wmiComboBox.Items.Add("Win32_BIOS"                       );
            this.wmiComboBox.Items.Add("Win32_Bus"                        );
            this.wmiComboBox.Items.Add("Win32_CDROMDrive"                 );
            this.wmiComboBox.Items.Add("Win32_DiskDrive"                  );
            this.wmiComboBox.Items.Add("Win32_DMAChannel"                 );
            this.wmiComboBox.Items.Add("Win32_Fan"                        );
            this.wmiComboBox.Items.Add("Win32_FloppyController"           );
            this.wmiComboBox.Items.Add("Win32_FloppyDrive"                );
            this.wmiComboBox.Items.Add("Win32_IDEController"              );
            this.wmiComboBox.Items.Add("Win32_IRQResource"                );
            this.wmiComboBox.Items.Add("Win32_Keyboard"                   );
            this.wmiComboBox.Items.Add("Win32_MemoryDevice"               );
            this.wmiComboBox.Items.Add("Win32_NetworkAdapter"             );
            this.wmiComboBox.Items.Add("Win32_NetworkAdapterConfiguration");
            this.wmiComboBox.Items.Add("Win32_OnBoardDevice"              );
            this.wmiComboBox.Items.Add("Win32_ParallelPort"               );
            this.wmiComboBox.Items.Add("Win32_PCMCIAController"           );
            this.wmiComboBox.Items.Add("Win32_PhysicalMedia"              );
            this.wmiComboBox.Items.Add("Win32_PhysicalMemory"             );
            this.wmiComboBox.Items.Add("Win32_PortConnector"              );
            this.wmiComboBox.Items.Add("Win32_PortResource"               );
            this.wmiComboBox.Items.Add("Win32_Processor"                  );
            this.wmiComboBox.Items.Add("Win32_SCSIController"             );
            this.wmiComboBox.Items.Add("Win32_SerialPort"                 );
            this.wmiComboBox.Items.Add("Win32_SerialPortConfiguration"    );
            this.wmiComboBox.Items.Add("Win32_SoundDevice"                );
            this.wmiComboBox.Items.Add("Win32_SystemEnclosure"            );
            this.wmiComboBox.Items.Add("Win32_TapeDrive"                  );
            this.wmiComboBox.Items.Add("Win32_TemperatureProbe"           );
            this.wmiComboBox.Items.Add("Win32_UninterruptiblePowerSupply" );
            this.wmiComboBox.Items.Add("Win32_USBController"              );
            this.wmiComboBox.Items.Add("Win32_USBHub"                     );
            this.wmiComboBox.Items.Add("Win32_VideoController"            );
            this.wmiComboBox.Items.Add("Win32_VoltageProbe"               );

            this.wmiComboBox.SelectedIndex = 0;
        }

        #endregion
        #region WMI 콤보 박스 선택 인덱스 변경시 처리하기 - wmiComboBox_SelectedIndexChanged(sender, e)

        /// <summary>
        /// WMI 콤보 박스 선택 인덱스 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void wmiComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if(this.wmiComboBox.SelectedItem != null)
            {
                this.listView.Items.Clear();

                SelectQuery selectQuery = new SelectQuery(this.wmiComboBox.SelectedItem as string);

                ManagementObjectSearcher managementObjectSearcher = new ManagementObjectSearcher(selectQuery);

                foreach(ManagementObject managementObject in managementObjectSearcher.Get())
                {
                    this.listView.Groups.Add(managementObject.ToString(), managementObject.Properties["Name"].Value.ToString());
                    
                    foreach(PropertyData propertyData in managementObject.Properties)
                    {
                        string valueString = null;

                        if(propertyData.Value != null)
                        {
                            valueString = propertyData.Value.ToString();
                        }

                        string[] itemArray = { propertyData.Name, valueString };

                        ListViewItem listViewItem = new ListViewItem(itemArray);

                        listViewItem.Group = listView.Groups[managementObject.ToString()] as ListViewGroup;

                        listView.Items.Add(listViewItem);
                    }
                }
            }
        }

        #endregion
    }
}